/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2004  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __VIFDMA_H__
#define __VIFDMA_H__

typedef struct {
   int addr;
   int size;
   int cmd;
   u32 wl;
   u32 cl;
} vifCode;

typedef struct {
	vifCode tag;
	int cmd;
	int usn;
} vifStruct;

vifStruct vif0;
vifStruct vif1;

void UNPACK_S_32M( u32 *dest, u32 *data );
void UNPACK_S_32Mpart( u32 *dest, u32 *data, int size );
void UNPACK_S_32M_O( u32 *dest, u32 *data );
void UNPACK_S_32Mpart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_32M_D( u32 *dest, u32 *data );
void UNPACK_S_32Mpart_D( u32 *dest, u32 *data, int size );

void UNPACK_S_16sM( u32 *dest, u32 *data );
void UNPACK_S_16sMpart( u32 *dest, u32 *data, int size );
void UNPACK_S_16uM( u32 *dest, u32 *data );
void UNPACK_S_16uMpart( u32 *dest, u32 *data, int size );
void UNPACK_S_16sM_O( u32 *dest, u32 *data );
void UNPACK_S_16sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_16uM_O( u32 *dest, u32 *data );
void UNPACK_S_16uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_16sM_D( u32 *dest, u32 *data );
void UNPACK_S_16sMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_S_16uM_D( u32 *dest, u32 *data );
void UNPACK_S_16uMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_S_8uM( u32 *dest, u32 *data );
void UNPACK_S_8uMpart( u32 *dest, u32 *data, int size );
void UNPACK_S_8sM( u32 *dest, u32 *data );
void UNPACK_S_8sMpart( u32 *dest, u32 *data, int size );
void UNPACK_S_8uM_O( u32 *dest, u32 *data );
void UNPACK_S_8uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_8sM_O( u32 *dest, u32 *data );
void UNPACK_S_8sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_8uM_D( u32 *dest, u32 *data );
void UNPACK_S_8uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_S_8sM_D( u32 *dest, u32 *data );
void UNPACK_S_8sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V2_32M( u32 *dest, u32 *data );
void UNPACK_V2_32Mpart( u32 *dest, u32 *data, int size );
void UNPACK_V2_32M_O( u32 *dest, u32 *data );
void UNPACK_V2_32Mpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_32M_D( u32 *dest, u32 *data );
void UNPACK_V2_32Mpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V2_16uM( u32 *dest, u32 *data );
void UNPACK_V2_16uMpart( u32 *dest, u32 *data, int size );
void UNPACK_V2_16sM( u32 *dest, u32 *data );
void UNPACK_V2_16sMpart( u32 *dest, u32 *data, int size );
void UNPACK_V2_16uM_O( u32 *dest, u32 *data );
void UNPACK_V2_16uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_16sM_O( u32 *dest, u32 *data );
void UNPACK_V2_16sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_16uM_D( u32 *dest, u32 *data );
void UNPACK_V2_16uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_V2_16sM_D( u32 *dest, u32 *data );
void UNPACK_V2_16sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V2_8uM( u32 *dest, u32 *data );
void UNPACK_V2_8uMpart( u32 *dest, u32 *data, int size );
void UNPACK_V2_8sM( u32 *dest, u32 *data );
void UNPACK_V2_8sMpart( u32 *dest, u32 *data, int size );
void UNPACK_V2_8uM_O( u32 *dest, u32 *data );
void UNPACK_V2_8uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_8sM_O( u32 *dest, u32 *data );
void UNPACK_V2_8sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_8uM_D( u32 *dest, u32 *data );
void UNPACK_V2_8uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_V2_8sM_D( u32 *dest, u32 *data );
void UNPACK_V2_8sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V3_32M( u32 *dest, u32 *data );
void UNPACK_V3_32Mpart( u32 *dest, u32 *data, int size );
void UNPACK_V3_32M_O( u32 *dest, u32 *data );
void UNPACK_V3_32Mpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_32M_D( u32 *dest, u32 *data );
void UNPACK_V3_32Mpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V3_16uM( u32 *dest, u32 *data );
void UNPACK_V3_16uMpart( u32 *dest, u32 *data, int size );
void UNPACK_V3_16sM( u32 *dest, u32 *data );
void UNPACK_V3_16sMpart( u32 *dest, u32 *data, int size );
void UNPACK_V3_16uM_O( u32 *dest, u32 *data );
void UNPACK_V3_16uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_16sM_O( u32 *dest, u32 *data );
void UNPACK_V3_16sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_16uM_D( u32 *dest, u32 *data );
void UNPACK_V3_16uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_V3_16sM_D( u32 *dest, u32 *data );
void UNPACK_V3_16sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V3_8uM( u32 *dest, u32 *data );
void UNPACK_V3_8uMpart( u32 *dest, u32 *data, int size );
void UNPACK_V3_8sM( u32 *dest, u32 *data );
void UNPACK_V3_8sMpart( u32 *dest, u32 *data, int size );
void UNPACK_V3_8uM_O( u32 *dest, u32 *data );
void UNPACK_V3_8uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_8sM_O( u32 *dest, u32 *data );
void UNPACK_V3_8sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_8uM_D( u32 *dest, u32 *data );
void UNPACK_V3_8uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_V3_8sM_D( u32 *dest, u32 *data );
void UNPACK_V3_8sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_32M( u32 *dest, u32 *data );
void UNPACK_V4_32Mpart( u32 *dest, u32 *data, int size );
void UNPACK_V4_32M_O( u32 *dest, u32 *data );
void UNPACK_V4_32Mpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_32M_D( u32 *dest, u32 *data );
void UNPACK_V4_32Mpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_16uM( u32 *dest, u32 *data );
void UNPACK_V4_16uMpart( u32 *dest, u32 *data, int size );
void UNPACK_V4_16sM( u32 *dest, u32 *data );
void UNPACK_V4_16sMpart( u32 *dest, u32 *data, int size );
void UNPACK_V4_16uM_O( u32 *dest, u32 *data );
void UNPACK_V4_16uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_16sM_O( u32 *dest, u32 *data );
void UNPACK_V4_16sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_16uM_D( u32 *dest, u32 *data );
void UNPACK_V4_16uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_V4_16sM_D( u32 *dest, u32 *data );
void UNPACK_V4_16sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_8uM( u32 *dest, u32 *data );
void UNPACK_V4_8uMpart( u32 *dest, u32 *data, int size );
void UNPACK_V4_8sM( u32 *dest, u32 *data );
void UNPACK_V4_8sMpart( u32 *dest, u32 *data, int size );
void UNPACK_V4_8uM_O( u32 *dest, u32 *data );
void UNPACK_V4_8uMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_8sM_O( u32 *dest, u32 *data );
void UNPACK_V4_8sMpart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_8uM_D( u32 *dest, u32 *data );
void UNPACK_V4_8uMpart_D( u32 *dest, u32 *data, int size );
void UNPACK_V4_8sM_D( u32 *dest, u32 *data );
void UNPACK_V4_8sMpart_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_5M( u32 *dest, u32 *data );
void UNPACK_V4_5Mpart( u32 *dest, u32 *data, int size );

void UNPACK_S_32( u32 *dest, u32 *data );
void UNPACK_S_32part( u32 *dest, u32 *data, int size );
void UNPACK_S_32_O( u32 *dest, u32 *data );
void UNPACK_S_32part_O( u32 *dest, u32 *data, int size );
void UNPACK_S_32_D( u32 *dest, u32 *data );
void UNPACK_S_32part_D( u32 *dest, u32 *data, int size );

void UNPACK_S_16u( u32 *dest, u32 *data );
void UNPACK_S_16upart( u32 *dest, u32 *data, int size );
void UNPACK_S_16s( u32 *dest, u32 *data );
void UNPACK_S_16spart( u32 *dest, u32 *data, int size );
void UNPACK_S_16u_O( u32 *dest, u32 *data );
void UNPACK_S_16upart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_16s_O( u32 *dest, u32 *data );
void UNPACK_S_16spart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_16u_D( u32 *dest, u32 *data );
void UNPACK_S_16upart_D( u32 *dest, u32 *data, int size );
void UNPACK_S_16s_D( u32 *dest, u32 *data );
void UNPACK_S_16spart_D( u32 *dest, u32 *data, int size );

void UNPACK_S_8u( u32 *dest, u32 *data );
void UNPACK_S_8upart( u32 *dest, u32 *data, int size );
void UNPACK_S_8s( u32 *dest, u32 *data );
void UNPACK_S_8spart( u32 *dest, u32 *data, int size );
void UNPACK_S_8u_O( u32 *dest, u32 *data );
void UNPACK_S_8upart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_8s_O( u32 *dest, u32 *data );
void UNPACK_S_8spart_O( u32 *dest, u32 *data, int size );
void UNPACK_S_8u_D( u32 *dest, u32 *data );
void UNPACK_S_8upart_D( u32 *dest, u32 *data, int size );
void UNPACK_S_8s_D( u32 *dest, u32 *data );
void UNPACK_S_8spart_D( u32 *dest, u32 *data, int size );

void UNPACK_V2_32( u32 *dest, u32 *data );
void UNPACK_V2_32part( u32 *dest, u32 *data, int size );
void UNPACK_V2_32_O( u32 *dest, u32 *data );
void UNPACK_V2_32part_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_32_D( u32 *dest, u32 *data );
void UNPACK_V2_32part_D( u32 *dest, u32 *data, int size );

void UNPACK_V2_16u( u32 *dest, u32 *data );
void UNPACK_V2_16upart( u32 *dest, u32 *data, int size );
void UNPACK_V2_16s( u32 *dest, u32 *data );
void UNPACK_V2_16spart( u32 *dest, u32 *data, int size );
void UNPACK_V2_16u_O( u32 *dest, u32 *data );
void UNPACK_V2_16upart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_16s_O( u32 *dest, u32 *data );
void UNPACK_V2_16spart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_16u_D( u32 *dest, u32 *data );
void UNPACK_V2_16upart_D( u32 *dest, u32 *data, int size );
void UNPACK_V2_16s_D( u32 *dest, u32 *data );
void UNPACK_V2_16spart_D( u32 *dest, u32 *data, int size );

void UNPACK_V2_8u( u32 *dest, u32 *data );
void UNPACK_V2_8upart( u32 *dest, u32 *data, int size );
void UNPACK_V2_8s( u32 *dest, u32 *data );
void UNPACK_V2_8spart( u32 *dest, u32 *data, int size );
void UNPACK_V2_8u_O( u32 *dest, u32 *data );
void UNPACK_V2_8upart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_8s_O( u32 *dest, u32 *data );
void UNPACK_V2_8spart_O( u32 *dest, u32 *data, int size );
void UNPACK_V2_8u_D( u32 *dest, u32 *data );
void UNPACK_V2_8upart_D( u32 *dest, u32 *data, int size );
void UNPACK_V2_8s_D( u32 *dest, u32 *data );
void UNPACK_V2_8spart_D( u32 *dest, u32 *data, int size );

void UNPACK_V3_32( u32 *dest, u32 *data );
void UNPACK_V3_32part( u32 *dest, u32 *data, int size );
void UNPACK_V3_32_O( u32 *dest, u32 *data );
void UNPACK_V3_32part_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_32_D( u32 *dest, u32 *data );
void UNPACK_V3_32part_D( u32 *dest, u32 *data, int size );

void UNPACK_V3_16u( u32 *dest, u32 *data );
void UNPACK_V3_16upart( u32 *dest, u32 *data, int size );
void UNPACK_V3_16s( u32 *dest, u32 *data );
void UNPACK_V3_16spart( u32 *dest, u32 *data, int size );
void UNPACK_V3_16u_O( u32 *dest, u32 *data );
void UNPACK_V3_16upart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_16s_O( u32 *dest, u32 *data );
void UNPACK_V3_16spart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_16u_D( u32 *dest, u32 *data );
void UNPACK_V3_16upart_D( u32 *dest, u32 *data, int size );
void UNPACK_V3_16s_D( u32 *dest, u32 *data );
void UNPACK_V3_16spart_D( u32 *dest, u32 *data, int size );

void UNPACK_V3_8u( u32 *dest, u32 *data );
void UNPACK_V3_8upart( u32 *dest, u32 *data, int size );
void UNPACK_V3_8s( u32 *dest, u32 *data );
void UNPACK_V3_8spart( u32 *dest, u32 *data, int size );
void UNPACK_V3_8u_O( u32 *dest, u32 *data );
void UNPACK_V3_8upart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_8s_O( u32 *dest, u32 *data );
void UNPACK_V3_8spart_O( u32 *dest, u32 *data, int size );
void UNPACK_V3_8u_D( u32 *dest, u32 *data );
void UNPACK_V3_8upart_D( u32 *dest, u32 *data, int size );
void UNPACK_V3_8s_D( u32 *dest, u32 *data );
void UNPACK_V3_8spart_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_32( u32 *dest, u32 *data );
void UNPACK_V4_32part( u32 *dest, u32 *data, int size );
void UNPACK_V4_32_O( u32 *dest, u32 *data );
void UNPACK_V4_32part_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_32_D( u32 *dest, u32 *data );
void UNPACK_V4_32part_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_16u( u32 *dest, u32 *data );
void UNPACK_V4_16upart( u32 *dest, u32 *data, int size );
void UNPACK_V4_16s( u32 *dest, u32 *data );
void UNPACK_V4_16spart( u32 *dest, u32 *data, int size );
void UNPACK_V4_16u_O(u32 *dest, u32 *data);
void UNPACK_V4_16upart_O(u32 *dest, u32 *data, int size);
void UNPACK_V4_16s_O(u32 *dest, u32 *data);
void UNPACK_V4_16spart_O(u32 *dest, u32 *data, int size);
void UNPACK_V4_16u_D(u32 *dest, u32 *data);
void UNPACK_V4_16upart_D(u32 *dest, u32 *data, int size);
void UNPACK_V4_16s_D(u32 *dest, u32 *data);
void UNPACK_V4_16spart_D(u32 *dest, u32 *data, int size);

void UNPACK_V4_8u( u32 *dest, u32 *data );
void UNPACK_V4_8upart( u32 *dest, u32 *data, int size );
void UNPACK_V4_8s( u32 *dest, u32 *data );
void UNPACK_V4_8spart( u32 *dest, u32 *data, int size );
void UNPACK_V4_8u_O( u32 *dest, u32 *data );
void UNPACK_V4_8upart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_8s_O( u32 *dest, u32 *data );
void UNPACK_V4_8spart_O( u32 *dest, u32 *data, int size );
void UNPACK_V4_8u_D( u32 *dest, u32 *data );
void UNPACK_V4_8upart_D( u32 *dest, u32 *data, int size );
void UNPACK_V4_8s_D( u32 *dest, u32 *data );
void UNPACK_V4_8spart_D( u32 *dest, u32 *data, int size );

void UNPACK_V4_5( u32 *dest, u32 *data );
void UNPACK_V4_5part( u32 *dest, u32 *data, int size );


void vifDmaInit();
void vif0Init();
void vif1Init();
int  vif0Interrupt();
int  vif1Interrupt();

void vif0Reset();
void vif1Reset();
int  vif0Freeze(gzFile f, int Mode);
int  vif1Freeze(gzFile f, int Mode);

#endif
